From 033a639525f9e49668c3efa92705aeb9ef0b7d66 Mon Sep 17 00:00:00 2001
From: Jiri Gaisler <jiri@gaisler.se>
Date: Wed, 9 Aug 2017 22:52:45 +0200
Subject: [PATCH 11/11] sim/erc32: Fix to build on mingw64.

	* erc32.c, leon2.c, leon3.c: Remove unecessary include fo fcntl.h.
	Check existens of termios.h before using termios. Check for O_NONBLOCK.
	Change caddr_t to int32 tyoes in event handlers.
	* interf.c: Check for HAVE_FCNTL_H before including fcntl.h. Check
	for F_GETFL and F_SETFL before calling fcntl().
	* sis.c: As above.
	* configure.ac: Check for termios.h
	* config.in: Re-generate.
	* configure.in: Re-generate
---
 sim/erc32/config.in    |  3 +++
 sim/erc32/configure    | 21 ++++++++++++++---
 sim/erc32/configure.ac |  2 ++
 sim/erc32/erc32.c      | 37 ++++++++++++++++++++---------
 sim/erc32/func.c       | 64 ++++++++++++++++++++++++++++++++++++++++++++++++--
 sim/erc32/interf.c     |  6 +++++
 sim/erc32/leon2.c      | 27 +++++++++++++++------
 sim/erc32/leon3.c      | 27 +++++++++++++++------
 sim/erc32/sis.c        |  2 ++
 9 files changed, 159 insertions(+), 30 deletions(-)

diff --git a/sim/erc32/config.in b/sim/erc32/config.in
index aa3e45c..f9ce1d1 100644
--- a/sim/erc32/config.in
+++ b/sim/erc32/config.in
@@ -127,6 +127,9 @@
 /* Define to 1 if you have the <sys/types.h> header file. */
 #undef HAVE_SYS_TYPES_H
 
+/* Define to 1 if you have the <termios.h> header file. */
+#undef HAVE_TERMIOS_H
+
 /* Define to 1 if you have the `time' function. */
 #undef HAVE_TIME
 
diff --git a/sim/erc32/configure.ac b/sim/erc32/configure.ac
index 8b430d9..6e1ae77 100644
--- a/sim/erc32/configure.ac
+++ b/sim/erc32/configure.ac
@@ -20,6 +20,8 @@ sinclude(../common/acinclude.m4)
 
 SIM_AC_COMMON
 
+AC_CHECK_HEADERS(termios.h)
+
 # In the Cygwin environment, we need some additional flags.
 AC_CACHE_CHECK([for cygwin], sim_cv_os_cygwin,
 [AC_EGREP_CPP(lose, [
diff --git a/sim/erc32/erc32.c b/sim/erc32/erc32.c
index cc74fad..d2b9194 100644
--- a/sim/erc32/erc32.c
+++ b/sim/erc32/erc32.c
@@ -23,8 +23,9 @@
 #include <sys/types.h>
 #include <stdio.h>
 #include <string.h>
+#ifdef HAVE_TERMIOS_H
 #include <termios.h>
-#include <fcntl.h>
+#endif
 #include <sys/file.h>
 #include <unistd.h>
 #include "sis.h"
@@ -226,7 +227,13 @@ static char     wbufa[UARTBUF], wbufb[UARTBUF];
 static unsigned wnuma;
 static unsigned wnumb;
 static FILE    *f1in, *f1out, *f2in, *f2out;
+#ifdef HAVE_TERMIOS_H
 static struct termios ioc1, ioc2, iocold1, iocold2;
+#endif
+#ifndef O_NONBLOCK
+#define O_NONBLOCK 0
+#endif
+
 static int      f1open = 0, f2open = 0;
 
 static char     uarta_sreg, uarta_hreg, uartb_sreg, uartb_hreg;
@@ -263,17 +270,17 @@ static void	write_uart (uint32 addr, uint32 data);
 static void	flush_uart (void);
 static void	uarta_tx (void);
 static void	uartb_tx (void);
-static void	uart_rx (caddr_t arg);
-static void	uart_intr (caddr_t arg);
+static void	uart_rx (int32 arg);
+static void	uart_intr (int32 arg);
 static void	uart_irq_start (void);
-static void	wdog_intr (caddr_t arg);
+static void	wdog_intr (int32 arg);
 static void	wdog_start (void);
-static void	rtc_intr (caddr_t arg);
+static void	rtc_intr (int32 arg);
 static void	rtc_start (void);
 static uint32	rtc_counter_read (void);
 static void	rtc_scaler_set (uint32 val);
 static void	rtc_reload_set (uint32 val);
-static void	gpt_intr (caddr_t arg);
+static void	gpt_intr (int32 arg);
 static void	gpt_start (void);
 static uint32	gpt_counter_read (void);
 static void	gpt_scaler_set (uint32 val);
@@ -919,6 +926,7 @@ init_stdio()
 {
     if (dumbio)
 	return; /* do nothing */
+#ifdef HAVE_TERMIOS_H
     if (ifd1 == 0 && f1open) {
 	tcsetattr(0, TCSANOW, &ioc1);
 	tcflush (ifd1, TCIFLUSH);
@@ -927,6 +935,7 @@ init_stdio()
 	tcsetattr(0, TCSANOW, &ioc2);
 	tcflush (ifd2, TCIFLUSH);
     }
+#endif
 }
 
 static void
@@ -934,10 +943,12 @@ restore_stdio()
 {
     if (dumbio)
 	return; /* do nothing */
+#ifdef HAVE_TERMIOS_H
     if (ifd1 == 0 && f1open && tty_setup)
 	tcsetattr(0, TCSANOW, &iocold1);
     if (ifd2 == 0 && f2open && tty_setup)
 	tcsetattr(0, TCSANOW, &iocold2);
+#endif
 }
 
 #define DO_STDIO_READ( _fd_, _buf_, _len_ )          \
@@ -980,6 +991,7 @@ port_init()
 	if (sis_verbose)
 	    printf("serial port A on stdin/stdout\n");
         if (!dumbio) {
+#ifdef HAVE_TERMIOS_H
 	    tcgetattr (ifd1, &ioc1);
 	    if (tty_setup) {
 		iocold1 = ioc1;
@@ -987,6 +999,7 @@ port_init()
 		ioc1.c_cc[VMIN] = 0;
 		ioc1.c_cc[VTIME] = 0;
 	    }
+#endif
         }
 	f1open = 1;
     }
@@ -1012,6 +1025,7 @@ port_init()
 	if (sis_verbose)
 	    printf("serial port B on stdin/stdout\n");
         if (!dumbio) {
+#ifdef HAVE_TERMIOS_H
             tcgetattr(ifd2, &ioc2);
             if (tty_setup) {
 		iocold2 = ioc2;
@@ -1019,6 +1033,7 @@ port_init()
 		ioc2.c_cc[VMIN] = 0;
 		ioc2.c_cc[VTIME] = 0;
 	    }
+#endif
         }
 	f2open = 1;
     }
@@ -1308,7 +1323,7 @@ uartb_tx()
 
 static void
 uart_rx(arg)
-    caddr_t         arg;
+    int32         arg;
 {
     int32           rsize;
     char            rxd;
@@ -1355,7 +1370,7 @@ uart_rx(arg)
 
 static void
 uart_intr(arg)
-    caddr_t         arg;
+    int32         arg;
 {
     read_uart(0xE8);		/* Check for UART interrupts every 1000 clk */
     flush_uart();		/* Flush UART ports      */
@@ -1379,7 +1394,7 @@ uart_irq_start()
 
 static void
 wdog_intr(arg)
-    caddr_t         arg;
+    int32         arg;
 {
     if (wdog_status == disabled) {
 	wdog_status = stopped;
@@ -1418,7 +1433,7 @@ wdog_start()
 
 static void
 rtc_intr(arg)
-    caddr_t         arg;
+    int32         arg;
 {
     if (rtc_counter == 0) {
 
@@ -1472,7 +1487,7 @@ rtc_reload_set(val)
 
 static void
 gpt_intr(arg)
-    caddr_t         arg;
+    int32         arg;
 {
     if (gpt_counter == 0) {
 	mec_irq(12);
diff --git a/sim/erc32/func.c b/sim/erc32/func.c
index a94a0ca..1cf7e45 100644
--- a/sim/erc32/func.c
+++ b/sim/erc32/func.c
@@ -82,8 +82,9 @@ static int	disp_fpu (struct pstate  *sregs);
 static void	disp_regs (struct pstate  *sregs, int cwp);
 static void	disp_ctrl (struct pstate *sregs);
 static void	disp_mem (uint32 addr, uint32 len);
+static ssize_t 	mygetline (char **lineptr, size_t *n, FILE *stream);
 
-static int 
+static int
 batch(sregs, fname)
     struct pstate  *sregs;
     char           *fname;
@@ -97,7 +98,7 @@ batch(sregs, fname)
 	fprintf(stderr, "couldn't open batch file %s\n", fname);
 	return 0;
     }
-    while (getline(&lbuf, &len, fp) > -1) {
+    while (mygetline(&lbuf, &len, fp) > -1) {
 	slen = strlen(lbuf);
 	if (slen && (lbuf[slen - 1] == '\n')) {
 	    lbuf[slen - 1] = 0;
@@ -1242,3 +1243,62 @@ double get_time (void)
     usec = ((double) tm.tv_sec) * 1E6 + ((double) tm.tv_usec);
     return usec / 1E6;
 }
+
+/* Local version of getline() since not all systems supports it */
+
+static const int line_size = 128;
+
+static ssize_t
+mygetdelim (char **lineptr, size_t *n, int delim, FILE *stream)
+{
+  int indx = 0;
+  int c;
+
+  /* Sanity checks.  */
+  if (lineptr == NULL || n == NULL || stream == NULL)
+    return -1;
+
+  /* Allocate the line the first time.  */
+  if (*lineptr == NULL)
+    {
+      *lineptr = malloc (line_size);
+      if (*lineptr == NULL)
+        return -1;
+      *n = line_size;
+    }
+
+  /* Clear the line.  */
+  memset (*lineptr, '\0', *n);
+
+  while ((c = getc (stream)) != EOF)
+    {
+      /* Check if more memory is needed.  */
+      if (indx >= *n)
+        {
+          *lineptr = realloc (*lineptr, *n + line_size);
+          if (*lineptr == NULL)
+            {
+              return -1;
+            }
+          /* Clear the rest of the line.  */
+          memset(*lineptr + *n, '\0', line_size);
+          *n += line_size;
+        }
+
+      /* Push the result in the line.  */
+      (*lineptr)[indx++] = c;
+
+      /* Bail out.  */
+      if (c == delim)
+        {
+          break;
+        }
+    }
+  return (c == EOF) ? -1 : indx;
+}
+
+static ssize_t
+mygetline (char **lineptr, size_t *n, FILE *stream)
+{
+  return mygetdelim (lineptr, n, '\n', stream);
+}
diff --git a/sim/erc32/interf.c b/sim/erc32/interf.c
index 3baf165..da0e7c3 100644
--- a/sim/erc32/interf.c
+++ b/sim/erc32/interf.c
@@ -21,7 +21,9 @@
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
+#ifdef HAVE_FCNTL_H
 #include <fcntl.h>
+#endif
 #include "sis.h"
 #include "libiberty.h"
 #include "bfd.h"
@@ -215,7 +217,9 @@ sim_open (kind, callback, abfd, argv)
 	  (*sim_callback->printf_filtered) (sim_callback, "CPU freq %3.1f MHz\n", sregs.freq);
     }
 
+#ifdef F_GETFL
     termsave = fcntl(0, F_GETFL, 0);
+#endif
     INIT_DISASSEMBLE_INFO(dinfo, stdout,(fprintf_ftype)fprintf);
 #ifdef HOST_LITTLE_ENDIAN
     dinfo.endian = BFD_ENDIAN_LITTLE;
@@ -239,7 +243,9 @@ sim_close(sd, quitting)
 {
 
     ms->exit_sim ();
+#if defined(F_GETFL) && defined(F_SETFL)
     fcntl(0, F_SETFL, termsave);
+#endif
 
 };
 
diff --git a/sim/erc32/leon2.c b/sim/erc32/leon2.c
index 231fa7a..09402f7 100644
--- a/sim/erc32/leon2.c
+++ b/sim/erc32/leon2.c
@@ -26,8 +26,9 @@
 #include <sys/types.h>
 #include <stdio.h>
 #include <string.h>
+#ifdef HAVE_TERMIOS_H
 #include <termios.h>
-#include <fcntl.h>
+#endif
 #include <sys/file.h>
 #include <unistd.h>
 #include "sis.h"
@@ -127,7 +128,13 @@ static char wbufa[UARTBUF], wbufb[UARTBUF];
 static unsigned wnuma;
 static unsigned wnumb;
 static FILE *f1in, *f1out;
+#ifdef HAVE_TERMIOS_H
 static struct termios ioc1, ioc2, iocold1, iocold2;
+#endif
+#ifndef O_NONBLOCK
+#define O_NONBLOCK 0
+#endif
+
 static int f1open = 0;
 
 static char uarta_sreg, uarta_hreg;
@@ -149,10 +156,10 @@ static uint32 grlib_read_uart (uint32 addr);
 static void grlib_write_uart (uint32 addr, uint32 data);
 static void flush_uart (void);
 static void uarta_tx (void);
-static void uart_rx (caddr_t arg);
-static void uart_intr (caddr_t arg);
+static void uart_rx (int32 arg);
+static void uart_intr (int32 arg);
 static void uart_irq_start (void);
-static void gpt_intr (caddr_t arg);
+static void gpt_intr (int32 arg);
 static void gpt_init (void);
 static void gpt_reset (void);
 static void gpt_scaler_set (uint32 val);
@@ -451,11 +458,13 @@ init_stdio (void)
 {
   if (dumbio)
     return;
+#ifdef HAVE_TERMIOS_H
   if (ifd1 == 0 && f1open)
     {
       tcsetattr (0, TCSANOW, &ioc1);
       tcflush (ifd1, TCIFLUSH);
     }
+#endif
 }
 
 static void
@@ -463,8 +472,10 @@ restore_stdio (void)
 {
   if (dumbio)
     return;
+#ifdef HAVE_TERMIOS_H
   if (ifd1 == 0 && f1open && tty_setup)
     tcsetattr (0, TCSANOW, &iocold1);
+#endif
 }
 
 #define DO_STDIO_READ( _fd_, _buf_, _len_ )          \
@@ -500,6 +511,7 @@ port_init (void)
 	printf ("serial port A on stdin/stdout\n");
       if (!dumbio)
 	{
+#ifdef HAVE_TERMIOS_H
 	  tcgetattr (ifd1, &ioc1);
 	  if (tty_setup)
 	    {
@@ -508,6 +520,7 @@ port_init (void)
 	      ioc1.c_cc[VMIN] = 0;
 	      ioc1.c_cc[VTIME] = 0;
 	    }
+#endif
 	}
       f1open = 1;
     }
@@ -700,7 +713,7 @@ uarta_tx (void)
 }
 
 static void
-uart_rx (caddr_t arg)
+uart_rx (int32 arg)
 {
   char rxd;
   int32 rsize = 0;
@@ -723,7 +736,7 @@ uart_rx (caddr_t arg)
 }
 
 static void
-uart_intr (caddr_t arg)
+uart_intr (int32 arg)
 {
   /* Check for UART interrupts every 1000 clk.  */
   grlib_read_uart (APBUART_STATUS);
@@ -747,7 +760,7 @@ uart_irq_start (void)
 /* TIMER */
 
 static void
-gpt_intr (caddr_t arg)
+gpt_intr (int32 arg)
 {
   int i;
 
diff --git a/sim/erc32/leon3.c b/sim/erc32/leon3.c
index ce2851a..0523411 100644
--- a/sim/erc32/leon3.c
+++ b/sim/erc32/leon3.c
@@ -27,8 +27,9 @@
 #include <sys/types.h>
 #include <stdio.h>
 #include <string.h>
+#ifdef HAVE_TERMIOS_H
 #include <termios.h>
-#include <fcntl.h>
+#endif
 #include <sys/file.h>
 #include <unistd.h>
 #include "sis.h"
@@ -126,7 +127,13 @@ static char wbufa[UARTBUF], wbufb[UARTBUF];
 static unsigned wnuma;
 static unsigned wnumb;
 static FILE *f1in, *f1out;
+#ifdef HAVE_TERMIOS_H
 static struct termios ioc1, ioc2, iocold1, iocold2;
+#endif
+#ifndef O_NONBLOCK
+#define O_NONBLOCK 0
+#endif
+
 static int f1open = 0;
 
 static char uarta_sreg, uarta_hreg;
@@ -148,10 +155,10 @@ static uint32 grlib_read_uart (uint32 addr);
 static void grlib_write_uart (uint32 addr, uint32 data);
 static void flush_uart (void);
 static void uarta_tx (void);
-static void uart_rx (caddr_t arg);
-static void uart_intr (caddr_t arg);
+static void uart_rx (int32 arg);
+static void uart_intr (int32 arg);
 static void uart_irq_start (void);
-static void gpt_intr (caddr_t arg);
+static void gpt_intr (int32 arg);
 static void gpt_init (void);
 static void gpt_reset (void);
 static void gpt_scaler_set (uint32 val);
@@ -445,11 +452,13 @@ init_stdio (void)
 {
   if (dumbio)
     return;
+#ifdef HAVE_TERMIOS_H
   if (ifd1 == 0 && f1open)
     {
       tcsetattr (0, TCSANOW, &ioc1);
       tcflush (ifd1, TCIFLUSH);
     }
+#endif
 }
 
 static void
@@ -457,8 +466,10 @@ restore_stdio (void)
 {
   if (dumbio)
     return;
+#ifdef HAVE_TERMIOS_H
   if (ifd1 == 0 && f1open && tty_setup)
     tcsetattr (0, TCSANOW, &iocold1);
+#endif
 }
 
 #define DO_STDIO_READ( _fd_, _buf_, _len_ )          \
@@ -496,6 +507,7 @@ port_init (void)
 	printf ("serial port A on stdin/stdout\n");
       if (!dumbio)
 	{
+#ifdef HAVE_TERMIOS_H
 	  tcgetattr (ifd1, &ioc1);
 	  if (tty_setup)
 	    {
@@ -504,6 +516,7 @@ port_init (void)
 	      ioc1.c_cc[VMIN] = 0;
 	      ioc1.c_cc[VTIME] = 0;
 	    }
+#endif
 	}
       f1open = 1;
     }
@@ -700,7 +713,7 @@ uarta_tx (void)
 }
 
 static void
-uart_rx (caddr_t arg)
+uart_rx (int32 arg)
 {
   char rxd;
   int32 rsize = 0;
@@ -724,7 +737,7 @@ uart_rx (caddr_t arg)
 }
 
 static void
-uart_intr (caddr_t arg)
+uart_intr (int32 arg)
 {
   /* Check for UART interrupts every 1000 clk.  */
   grlib_read_uart (APBUART_STATUS);
@@ -748,7 +761,7 @@ uart_irq_start (void)
 /* GPTIMER.  */
 
 static void
-gpt_intr (caddr_t arg)
+gpt_intr (int32 arg)
 {
   int i;
 
diff --git a/sim/erc32/sis.c b/sim/erc32/sis.c
index 85f105b..f78986e 100644
--- a/sim/erc32/sis.c
+++ b/sim/erc32/sis.c
@@ -242,7 +242,9 @@ main(argc, argv)
     dinfo.endian = BFD_ENDIAN_BIG;
 #endif
 
+#ifdef F_GETFL
     termsave = fcntl(0, F_GETFL, 0);
+#endif
     using_history();
     init_signals();
     ebase.simtime = 0;
-- 
2.7.4

